<?php

/*****************************************************************************/
function select_screen_palette ($id, &$pal_res, &$pal_index)
/*****************************************************************************/
{
	/* Description: Select palette for a screen.
	 * Parameters:
	 * - $id: Resource index of screen.
	 * - $pal_res: Palette resource.
	 * - $pal_index: Palette index.
	 * Returns: Nothing.
	 */

	$pal_res = 69; // palette resource
	$pal_index = -1; // palette index

	if ($id == 71) $pal_index = 1; /*** princess room ***/
	if ($id == 72) $pal_index = 1; /*** princess room arches ***/
	if ($id == 75) $pal_index = 6; /*** Masaya logo ***/
	if ($id == 76) $pal_index = 8; /*** stars before Masaya logo (probably wrong palette) ***/
	if ($id == 77) $pal_index = 18; /*** torture ***/
	if ($id == 78) $pal_index = 21; /*** garden ***/
	if ($id == 79) $pal_index = 8; /*** title ***/
	if ($id == 80) $pal_index = 8; /*** title moving things ***/
	if ($id == 81) $pal_index = 10; /*** carpet pattern (not used) ***/
	if ($id == 82) $pal_index = 8; /*** game name ***/
	if ($id == 83) $pal_index = 12; /*** main menu background ***/
	if ($id == 84) $pal_index = 12; /*** hallway where Jaffar walks ***/
	if ($id == 85) $pal_index = 16; /*** ending: prince at sultan ***/
	if ($id == 86) $pal_index = 16; /*** ending: prince and princess, with people ***/
	if ($id == 87) $pal_index = 16; /*** ending: prince and princess, with sundown ***/
	if ($id == 88) $pal_index = 17; /*** ending: sundown ***/
	if ($id == 89) $pal_index = 17; /*** ending: sundown 2 ***/
	if ($id == 90) $pal_index = 6; /*** Japanese characters ***/
	if ($id == 91) $pal_index = 26; /*** Konami logo ***/
}

/*****************************************************************************/
function select_sprite_palette ($id, &$pal_res, &$pal_index)
/*****************************************************************************/
{
	/* Description: Select palette for a sprite.
	 * Parameters:
	 * - $id: Resource index of sprite.
	 * - $pal_res: Palette resource.
	 * - $pal_index: Palette index.
	 * Returns: Nothing.
	 */

	$pal_res = 68; // palette resource
	$pal_index = -1; // palette index

	/*** prince ***/
	if ((($id >= 0) and ($id <= 63)) or
		(($id >= 65) and ($id <= 161)) or
		(($id >= 183) and ($id <= 196)) or
		(($id >= 276) and ($id <= 307)) or // shadow fighting (the last ones are leftover from Apple II?)
		(($id >= 404) and ($id <= 448)) or
		(($id >= 673) and ($id <= 696)) or // ending
		(($id >= 700) and ($id <= 751)) or // except 712..714?
		(($id >= 770) and ($id <= 803)) or
		(($id >= 1201) and ($id <= 1204)) or // sitting
		(($id >= 1153) and ($id <= 1156)) or // pulled on ground
		(($id >= 1221) and ($id <= 1231)) or // taken away
		(($id >= 364) and ($id <= 365))) // leftover from Apple II?
		{ $pal_index = 0; } // 0=regular, 1=red, 2=slow-fall, 10=shadow

	/*** fat ***/
	if (($id >= 212) and ($id <= 275))
		{ $pal_index = 9; }

	/*** guard ***/
	if ((($id >= 244) and ($id <= 275)) or
		(($id >= 1157) and ($id <= 1200)) or // torture
		(($id >= 1246) and ($id <= 1248))) // with stick
		{ $pal_index = 11; } // 11=yellow/green, 12=green/blue, 13=blue, 14=red, 15=purple, 16=blueface

	/*** skeleton ***/
	if (($id >= 308) and ($id <= 339))
		{ $pal_index = 4; } // 4=regular, 5=brown, 6=golden, 7=level 10

	/*** knight ***/
	if ((($id >= 340) and ($id <= 363)) or
		(($id >= 366) and ($id <= 371)))
		{ $pal_index = 17; } // 17=red, 18=blue

	/*** Jaffar ***/
	if ((($id >= 372) and ($id <= 403)) or
		(($id >= 522) and ($id <= 551)) or
		(($id >= 625) and ($id <= 632)) or
		(($id >= 813) and ($id <= 935)) or
		(($id >= 1139) and ($id <= 1144)))
		{ $pal_index = 20; }

	/*** princess ***/
	if ((($id >= 449) and ($id <= 521)) or
		(($id >= 552) and ($id <= 624)) or
		(($id >= 633) and ($id <= 672)) or // ending
		(($id >= 1205) and ($id <= 1220)) or // sitting
		(($id >= 1232) and ($id <= 1235))) // waving
		{ $pal_index = 3; }

	/*** amazon ***/
	if (($id >= 936) and ($id <= 988))
		{ $pal_index = 8; }

	/*** six-armed monster ***/
	if (($id >= 989) and ($id <= 1064))
		{ $pal_index = 19; }

	/*** mouse ***/
	if (($id >= 1077) and ($id <= 1086))
		{ $pal_index = 21; }

	/*** prince dying in fire ***/
	if (($id >= 752) and ($id <= 769))
		{ $pal_index = 23; }

	/*** potions ***/
	if (($id >= 1088) and ($id <= 1096))
		{ $pal_index = 24; }

	/*** hourglass ***/
	if (($id >= 1097) and ($id <= 1108))
	{
		$pal_res = 69;
		$pal_index = 5;
	}

	/*** elephant (ending) ***/
	if (($id >= 1145) and ($id <= 1152))
		{ $pal_res = 69; $pal_index = 17; }

	/*** flame and hardhit ***/
	if (($id == 64) or ($id == 1087))
		{ $pal_index = 23; }

	/*** sword ***/
	if ((($id >= 162) and ($id <= 182)) or
		(($id >= 199) and ($id <= 211)) or
		(($id >= 804) and ($id <= 812)) or
		(($id >= 697) and ($id <= 699)))
		{ $pal_index = 22; }

	/*** skull (from level 17 boss fight) ***/
	if (($id >= 1065) and ($id <= 1076))
		{ $pal_index = 25; }

	/*** pegasus (from Masaya logo) ***/
	if (($id >= 1109) and ($id <= 1138))
	{
		$pal_res = 69;
		$pal_index = 6;
	}

	/*** fountain water (intro) ***/
	if (($id >= 1243) and ($id <= 1245))
	{
		$pal_res = 69;
		$pal_index = 22;
	}
	/*** shooting star (level 20) ***/
	if (($id >= 1137) and ($id <= 1138))
	{
		$pal_res = 68;
		$pal_index = 26;
	}
	/*** ??? ***/
	if (($id >= 1236) and ($id <= 1242))
	{
		$pal_res = -1;
		$pal_index = -1;
	}
}

/*****************************************************************************/
function select_bg_sprite_palette ($id, &$pal_res, &$pal_index)
/*****************************************************************************/
{
	/* Description: Select palette for a background sprite.
	 * Parameters:
	 * - $id: Resource index of sprite.
	 * - $pal_res: Palette resource.
	 * - $pal_index: Palette index.
	 * Returns: Nothing.
	 */

	$pal_res = 68; // palette resource
	$pal_index = -1; // palette index

	/**** Floor tiles and exit doors ****/

	/*** blue dungeon ***/
	if ((($id >= 1249) and ($id <= 1254)) or
		($id==1297)) { $pal_res = 4; $pal_index = 6; }

	/*** pink palace ***/
	if ((($id >= 1255) and ($id <= 1260)) or
		($id == 1298)) { $pal_res = 8; $pal_index = 6; }

	/*** grey palace ***/
	if ((($id >= 1261) and ($id <= 1266)) or
		($id == 1299)) { $pal_res = 12; $pal_index = 6; }

	/*** red dungeon ***/
	if ((($id >= 1267) and ($id <= 1272)) or
		($id == 1300)) { $pal_res = 16; $pal_index = 6; }

	/*** green palace ***/
	if ((($id >= 1273) and ($id <= 1278)) or
		($id == 1301)) { $pal_res = 20; $pal_index = 6; }

	/*** brown dungeon ***/
	if ((($id >= 1279) and ($id <= 1284)) or
		($id == 1302)) { $pal_res = 24; $pal_index = 6; }

	/*** red palace ***/
	if ((($id >= 1285) and ($id <= 1290)) or
		($id == 1303)) { $pal_res = 28; $pal_index = 6; }

	/*** green palace bluish ***/
	if (($id >= 1291) and ($id <= 1296)) { $pal_res = 20; $pal_index = 6; }

	/*** level 20 (exit door) ***/
	if ($id == 1304) { $pal_res = 32; $pal_index = 6; }

	/**** Others ****/

	if (($id >= 1305) and ($id <= 1314)) { $pal_res = 4; $pal_index = 6; } /*** chomper ***/
	if (($id >= 1315) and ($id <= 1333)) { $pal_res = 4; $pal_index = 6; } /*** guillotine ***/
	if (($id >= 1334) and ($id <= 1339)) { $pal_res = 24; $pal_index = 6; } /*** spinning log ***/
	if (($id >= 1340) and ($id <= 1345)) { $pal_res = 4; $pal_index = 6; } /*** spike ***/
	if ($id == 1346) { $pal_res = 4; $pal_index = 6; } /*** unknown trap? ***/
	if (($id >= 1347) and ($id <= 1358)) { $pal_res = 24; $pal_index = 6; } /*** stars ***/
	if (($id >= 1359) and ($id <= 1369)) { $pal_res = 4; $pal_index = 6; } /*** gate ***/
	if ($id == 1370) { $pal_res = 8; $pal_index = 6; } /*** mirror ***/
	if ($id == 1371) { $pal_res = 4; $pal_index = 6; } /*** skeleton ***/
	if ($id == 1372) { $pal_res = 4; $pal_index = 6; } /*** unknown trap ***/
	if (($id >= 1373) and ($id <= 1379)) { $pal_res = 4; $pal_index = 6; } /*** crusher ***/
	if (($id >= 1380) and ($id <= 1383)) { $pal_res = 4; $pal_index = 6; } /*** shadow floor ***/
	if (($id >= 1384) and ($id <= 1387)) { $pal_res = 16; $pal_index = 6; } /*** fire ***/
	if (($id >= 1388) and ($id <= 1394)) { $pal_res = 4; $pal_index = 6; } /*** conveyor ***/
}

?>